Set $HOME to $scratchdir so that our tests are not affected by
[rsync/rsync.git] / testsuite / rsync.fns
1 #! /bin/sh
2
3 # Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5 # General-purpose test functions for rsync.
6
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License version
9 # 2 as published by the Free Software Foundation.
10 #
11 # This program is distributed in the hope that it will be useful, but
12 # WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
14 # Lesser General Public License for more details.
15
16 # You should have received a copy of the GNU Lesser General Public
17 # License along with this program; if not, write to the Free Software
18 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
21 tmpdir="$scratchdir"
22 fromdir="$tmpdir/from"
23 todir="$tmpdir/to"
24 chkdir="$tmpdir/chk"
25
26 # Berkley's nice.
27 PATH="$PATH:/usr/ucb"
28
29 if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
30     diffopt="-u"
31 else
32     diffopt="-c"
33 fi
34
35 HOME="$scratchdir"
36 export HOME
37
38 runtest() {
39     echo $ECHO_N "Test $1: $ECHO_C"
40     if eval "$2"
41     then
42         echo "$ECHO_T   done."
43         return 0
44     else
45         echo "$ECHO_T failed!"
46         return 1
47     fi
48 }
49
50 printmsg() {
51     echo "$1"
52 }
53
54
55 rsync_ls_lR() {
56     find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls"
57 }
58
59 rsync_getgroups() { 
60     "$TOOLDIR/getgroups"
61 }
62
63
64 ####################
65 # Build test directories $todir and $fromdir, with $fromdir full of files.
66
67 hands_setup() {
68     # Clean before creation
69     rm -rf "$fromdir"
70     rm -rf "$todir"
71
72     [ -d "$tmpdir" ] || mkdir "$tmpdir"
73     [ -d "$fromdir" ] || mkdir "$fromdir"
74     [ -d "$todir" ] || mkdir "$todir"
75
76     # On some BSD systems, the umask affects the mode of created
77     # symlinks, even though the mode apparently has no effect on how
78     # the links behave in the future, and it cannot be changed using
79     # chmod!  rsync always sets its umask to 000 so that it can
80     # accurately recreate permissions, but this script is probably run
81     # with a different umask. 
82
83     # This causes a little problem that "ls -l" of the two will not be
84     # the same.  So, we need to set our umask before doing any creations.
85
86     # set up test data
87     touch "$fromdir/empty"
88     mkdir "$fromdir/emptydir"
89
90     # a hundred lines of text or so
91     rsync_ls_lR "$srcdir" > "$fromdir/filelist"
92
93     echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
94     umask 0
95     ln -s nolf "$fromdir/nolf-symlink"
96     umask 022
97
98     cat "$srcdir"/*.c > "$fromdir/text"
99     mkdir "$fromdir/dir"
100     cp "$fromdir/text" "$fromdir/dir"
101     mkdir "$fromdir/dir/subdir"
102     echo some data > "$fromdir/dir/subdir/foobar.baz"
103     mkdir "$fromdir/dir/subdir/subsubdir"
104     if [ -r /etc ]; then
105         ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
106     else
107         ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
108     fi
109     mkdir "$fromdir/dir/subdir/subsubdir2"
110     if [ -r /bin ]; then
111         ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
112     else
113         ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
114     fi
115
116 #      echo testing head:
117 #      ls -lR "$srcdir" | head -10 || echo failed
118 }
119
120
121 ####################
122 # Many machines do not have "mkdir -p", so we have to build up long paths.
123 # How boring.  
124 makepath () {
125     echo "        makepath $1"
126     p="$1"
127     (
128         # Absolut Unix.
129         if echo $p | grep '^/' >/dev/null
130         then
131             cd /
132         fi
133     
134         # This will break if $1 contains a space.
135         for c in `echo $p | tr '/' ' '`
136         do 
137             if [ -d "$c" ] || mkdir "$c" 
138             then
139                 cd "$c" || return $?
140             else
141                 echo "failed to create $c" >&2; return $?
142             fi
143         done
144     )
145 }
146
147
148
149 ###########################
150 # Run a test (in '$1') then compare directories $2 and $3 to see if
151 # there are any difference.  If there are, explain them.
152
153 # So normally basically $1 should be an rsync command, and $2 and $3
154 # the source and destination directories.  This is only good when you
155 # expect to transfer the whole directory exactly as is.  If some files
156 # should be excluded, you might need to use something else.
157
158 checkit() {
159     failed=
160
161     # We can just write everything to stdout/stderr, because the
162     # wrapper hides it unless there is a problem.
163
164     echo "Running: \"$1\""  
165     eval "$1" 
166     status=$?
167     if [ $status != 0 ]; then
168         failed="YES";
169     fi
170
171     echo "-------------"
172     echo "check how the directory listings compare with diff:"
173     echo ""
174     ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
175     ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
176     diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
177
178     echo "-------------"
179     echo "check how the files compare with diff:"
180     echo ""
181     if [ "x$4" != x ]; then
182         echo "  === Skipping (as directed) ==="
183     else
184         diff -r $diffopt "$2" "$3" || failed=YES
185     fi
186
187     echo "-------------"
188     if [ -z "$failed" ] ; then
189         return 0
190     else
191         return 1
192     fi
193 }
194
195
196 build_rsyncd_conf() {
197     # Build an appropriate configuration file
198     conf="$scratchdir/test-rsyncd.conf"
199     echo "building configuration $conf"
200
201     port=2612
202     pidfile="$scratchdir/rsyncd.pid"
203     logfile="$scratchdir/rsyncd.log"
204
205     cat >"$conf" <<EOF
206 # rsyncd configuration file autogenerated by $0
207
208 pid file = $pidfile
209 use chroot = no
210 hosts allow = localhost, 127.0.0.1
211 log file = $logfile
212 exclude = foobar.baz
213 max verbosity = 9
214
215 uid = 0
216 gid = 0
217
218 [test-from]
219         path = $fromdir
220         read only = yes
221
222 [test-to]
223         path = $todir
224         read only = no
225 EOF
226 }
227
228
229 build_symlinks() {
230     mkdir "$fromdir"
231     date >"$fromdir/referent"
232     ln -s referent "$fromdir/relative"
233     ln -s "$fromdir/referent" "$fromdir/absolute"
234     ln -s nonexistent "$fromdir/dangling"
235     ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
236 }
237
238 test_fail() {
239     echo "$@" >&2
240     exit 1
241 }
242
243 test_skipped() {
244     echo "$@" >&2
245     echo "$@" > "$tmpdir/whyskipped"
246     exit 77
247 }
248
249 # It failed, but we expected that.  don't dump out error logs, 
250 # because most users won't want to see them.  But do leave
251 # the working directory around.
252 test_xfail() {
253     echo "$@" >&2
254     exit 78
255 }
256
257 # Determine what shell command will appropriately test for links.
258 ln -s foo "$scratchdir/testlink"
259 for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
260 do
261     for switch in -h -L
262     do
263         if $cmd $switch "$scratchdir/testlink" 2>/dev/null
264         then
265             # how nice
266             TEST_SYMLINK_CMD="$cmd $switch"
267             # i wonder if break 2 is portable?
268             break 2
269         fi
270    done
271 done
272 # ok, now get rid of it
273 rm "$scratchdir/testlink"
274
275
276 if [ "x$TEST_SYMLINK_CMD" = 'x' ]
277 then
278     test_fail "Couldn't determine how to test for symlinks"
279 else
280     echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
281 fi
282         
283
284 # Test whether something is a link, allowing for shell peculiarities
285 is_a_link() {
286     # note the variable contains the first option and therefore is not quoted
287     $TEST_SYMLINK_CMD "$1"
288 }
289
290
291 # We need to set the umask to be reproducible.  Note also that when we
292 # do some daemon tests as root, we will setuid() and therefore the
293 # directory has to be writable by the nobody user in some cases.  The
294 # best thing is probably to explicitly chmod those directories after
295 # creation.
296  
297 umask 022